
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

//
//
//
//
//

#include <stdlib.mqh>

//
//
//
//
//

extern string Name_Expert            = "BrainWashing";
extern bool   EcnBroker              = true;
extern bool   NoHedge                = true;
extern bool   StrictNoHedge          = true;
extern bool   UseAutoMagic           = true;
extern int    ManualMagic            = 17171717;  
extern double lStopLoss              = 100;
extern double sStopLoss              = 100;
extern double lTakeProfit            = 200;
extern double sTakeProfit            = 200;
extern double lTrailingStop          = 20;
extern double sTrailingStop          = 20;
extern int    Slippage               = 4;
extern double Lots                   = 0.1;
extern double MaximumRisk            = 0;
extern double DecreaseFactor         = 3;

extern string ah                     = "Price Channel Stop Trailing";
extern string ah1                    = "need lTrailing stop=0";
extern string ah2                    = "and sTrailing stop=0";
extern bool   UsePCSTrail            = false;
extern int    ts.ChannelPeriod       = 34;    
extern double ts.Risk                = 0.3; 
extern int    ts.entrybar            = 2;
extern int    TrailStep              = 0;

extern bool   useCloseTradeRules     = false;
extern bool   useCloseOnTrendChange  = false;

extern string INDICATOR_ONE          = "PriceChannel_Stop_v1";
extern int    ChannelPeriod          = 9;    
extern double Risk                   = 0.3;     
extern int    entrybar               = 1;

extern string _INDICATOR_2           = "i_Trend";
extern bool   ItrendFilter           = true;
extern int    Price                  = 0;
extern double ItPeriod               = 13;
extern double PowerPeriod            = 13;
extern int    MaMethod               = MODE_LWMA;
extern int    LevelBars              = 425;
extern double LevelFactor            = 0.20;

extern string INDICATOR_CloseONE     = "PC_Stop_for trend change close";
extern int    cl.ChannelPeriod       = 9;    
extern double cl.Risk                = 0.3; 
extern int    cl.entrybar            = 1;

extern string closetradeRules        = "PC_Stop Sig._for close trade rules";
extern int    cl2.ChannelPeriod      = 14;    
extern double cl2.Risk               = 0.3; 
extern int    cl2.entrybar           = 1;

extern string  ____TimeFilter        = "Time filter settings";
extern string  Trade.startFrom       = "00:00";
extern string  Trade.endAt           = "24:00";

extern string __fricl                = "Setting for friday positions close";
extern bool   CloseOnFriday          = false;
extern int    FridayCloseHour        = 21; // will be used only if CloseOnFriday == true
extern int    FridayCloseMinute      = 59; // will be used only if CloseOnFriday == true

extern bool   ShowAlerts             = false;
extern color  clOpenBuy              = Blue;
extern color  clCloseBuy             = Aqua;
extern color  clOpenSell             = Red;
extern color  clCloseSell            = Violet;

//
//
//
//
//

string s_symbol;

int    MAGIC;
int    digit;

double point = 1;
double iTredn1;
double iTredn2;
double iTredn3;

//
//
//
//
//

int init() 
{
  s_symbol = Symbol();
  
  digit  = MarketInfo(s_symbol,MODE_DIGITS);
  if (digit==2 || digit==4) point = 1;
  if (digit==3 || digit==5) point = 10;
  if (digit==6)             point = 100;
  
  if (UseAutoMagic) MAGIC = GetMagic();
              else  MAGIC = ManualMagic;  
              
return(0);
}

//
//
//
//
//

int deinit() { Comment(""); return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   
   if (Bars < 100) { Print("bars less than 100"); return(0); }
   if (lTrailingStop==0 && sTrailingStop==0 && UsePCSTrail) PCS_TS();
   
   //
   //
   //
   //
   //
   
   bool canEnterNewTrade = true;
   if (canEnterNewTrade)
   {
      string     st1 = normalizeTime(Trade.startFrom);
      string     et1 = normalizeTime(Trade.endAt);
      datetime   ts1 = StrToTime(TimeToStr(TimeCurrent(),TIME_DATE)+st1); datetime ts2 = ts1;
      datetime   te1 = StrToTime(TimeToStr(TimeCurrent(),TIME_DATE)+et1); datetime te2 = te1;
      if (te1<ts1) { ts1 -= 24*60*60; te2 += 24*60*60; }
        canEnterNewTrade = ((TimeCurrent()>=ts1 && TimeCurrent()<=te1) || (TimeCurrent()>=ts2 && TimeCurrent()<=te2));
   }
   
   //
   //
   //
   //
   //
   
   if (CloseOnFriday && TimeDayOfWeek(TimeCurrent())==5)
   {
     if (TimeHour(TimeCurrent()) > FridayCloseHour ||
        (TimeHour(TimeCurrent())== FridayCloseHour && TimeMinute(TimeCurrent())>= FridayCloseMinute))
     {
       for(int i=OrdersTotal()-1; i>=0; i--)
  	    { 
     	   OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
            if(OrderSymbol()     != s_symbol)    continue;
            if(OrderMagicNumber()!= MAGIC)       continue;

            if(OrderType()==OP_BUY)      { OrderClose(OrderTicket(),OrderLots(),Ask,0,CLR_NONE); continue; }
            if(OrderType()==OP_SELL)     { OrderClose(OrderTicket(),OrderLots(),Bid,0,CLR_NONE); continue; }
       }
       return(0);
     }
   }
   
   //
   //
   //
   //
   //
   
   double Buynow  = iCustom(NULL,0,"PriceChannel_Stop_v1",ChannelPeriod,Risk,0,entrybar);
   double Buypre  = iCustom(NULL,0,"PriceChannel_Stop_v1",ChannelPeriod,Risk,0,entrybar+1);
   double Sellnow = iCustom(NULL,0,"PriceChannel_Stop_v1",ChannelPeriod,Risk,1,entrybar);
   double Sellpre = iCustom(NULL,0,"PriceChannel_Stop_v1",ChannelPeriod,Risk,1,entrybar+1);
          iTredn1 = iCustom(NULL,0,"iTrend",Price,ItPeriod,PowerPeriod,MaMethod,LevelBars,LevelFactor,0,entrybar); //green
          iTredn2 = iCustom(NULL,0,"iTrend",Price,ItPeriod,PowerPeriod,MaMethod,LevelBars,LevelFactor,1,entrybar); //green
          iTredn3 = iCustom(NULL,0,"iTrend",Price,ItPeriod,PowerPeriod,MaMethod,LevelBars,LevelFactor,2,entrybar); //green
   
   //
   //
   //
   //
   //
   
   if (!ExistPositions() && canEnterNewTrade)
   {
      
     if (Buynow!=EMPTY_VALUE && Buypre==EMPTY_VALUE && Sellnow==EMPTY_VALUE && Sellpre==EMPTY_VALUE && ((ItrendFilter && iTredn1 > iTredn3 && iTredn1 > iTredn2 && canOpen(OP_BUY)) ||!ItrendFilter && canOpen(OP_BUY))) 
     {
        OpenBuy();
        return(0);
     }

     if (Buynow==EMPTY_VALUE && Buypre==EMPTY_VALUE && Sellnow!=EMPTY_VALUE && Sellpre==EMPTY_VALUE && ((ItrendFilter && iTredn2 > iTredn3 && iTredn2 > iTredn1 && canOpen(OP_SELL)) ||!ItrendFilter && canOpen(OP_SELL))) 
     {
        OpenSell();
        return(0);
     }
      
   }
   
   if (lTrailingStop > 0) TrailingPositionsBuy();
   if (sTrailingStop > 0) TrailingPositionsSell();
   if (useCloseOnTrendChange) CheckForClose();
   if (useCloseTradeRules)    CheckForClose2();
   
return (0);
}

//
//
//
//
//

bool ExistPositions() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) {
				return(true);
			}
		} 
   }
return(false);
}

//
//
//
//
//

void TrailingPositionsBuy() { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_BUY) { 
               if (Bid-OrderOpenPrice()     > lTrailingStop * Point * point) { 
                  if (OrderStopLoss() < Bid - lTrailingStop * Point * point) 
                      ModifyStopLoss(Bid    - lTrailingStop * Point * point); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void TrailingPositionsSell() { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_SELL) { 
               if (OrderOpenPrice() - Ask   > sTrailingStop * Point * point) { 
                  if (OrderStopLoss() > Ask + sTrailingStop * Point * point || OrderStopLoss() == 0)  
                      ModifyStopLoss(Ask    + sTrailingStop * Point * point); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void ModifyStopLoss(double ldStopLoss) 
{ 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE); 
   
   if (fm == false)
   {
	  int    ErrorCode = GetLastError();
	  string ErrDesc   = ErrorDescription(ErrorCode);

	  string ErrAlert  = StringConcatenate("Trailing Stop Modification - Error ",ErrorCode,": ",ErrDesc);
	  if (ShowAlerts   == true) Alert(ErrAlert);

	  string ErrLog    = StringConcatenate("Ask: ",MarketInfo(s_symbol,MODE_ASK)," Ticket: ",OrderTicket()," Stop: ",OrderStopLoss()," Trail: ",ldStopLoss);
	  Print(ErrLog);
	}
 
} 

//----------------------------------------------------------------------------------------
//      
//----------------------------------------------------------------------------------------
//
//
//
//
//

void PCS_TS()
{
   RefreshRates();
   double upLinenow = iCustom(NULL,0,"PriceChannel_Stop_v1",ts.ChannelPeriod,ts.Risk,4,ts.entrybar);
   double upLinepre = iCustom(NULL,0,"PriceChannel_Stop_v1",ts.ChannelPeriod,ts.Risk,4,ts.entrybar+1);
   double dnLinenow = iCustom(NULL,0,"PriceChannel_Stop_v1",ts.ChannelPeriod,ts.Risk,5,ts.entrybar);
   double dnLinepre = iCustom(NULL,0,"PriceChannel_Stop_v1",ts.ChannelPeriod,ts.Risk,5,ts.entrybar+1);

   //
   //
   //
   //
   //
   
   for (int i = 0; i <= OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
      if(OrderMagicNumber() != MAGIC) continue;
      if(OrderSymbol() != s_symbol)   continue;
         
      //
      //
      //
      //
      //
         
      if (OrderType() == OP_BUY)
      {
         if (upLinenow!=EMPTY_VALUE && dnLinenow==EMPTY_VALUE && (OrderOpenPrice()+TrailStep*point) < upLinenow)
         {
           if (NormalizeDouble(upLinenow,digit) > NormalizeDouble(OrderStopLoss(),digit))
           {
              bool buyTsMod = OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(upLinenow,digit),OrderTakeProfit(),0,Blue);
              
              if (buyTsMod == false)
              {
                 int    ErrorCode = GetLastError();
	              string ErrDesc   = ErrorDescription(ErrorCode);

	              string ErrAlert  = StringConcatenate("Trailing Stop Modification ",ErrorCode,": ",ErrDesc);
	              if (ShowAlerts   == true) Alert(ErrAlert);

	              string ErrLog    = StringConcatenate("Ask: ",MarketInfo(s_symbol,MODE_ASK)," Ticket: ",OrderTicket()," Stop: ",OrderStopLoss());
	              Print(ErrLog);
              }
            }
         }
         break;
      }
      
      //
      //
      //
      //
      //
      
      if (OrderType() == OP_SELL)
      {
         if (upLinenow==EMPTY_VALUE && dnLinenow!=EMPTY_VALUE && (OrderOpenPrice()-TrailStep*point) > dnLinenow)
         {
            if (NormalizeDouble(dnLinenow,digit) < NormalizeDouble(OrderStopLoss(),digit) || OrderStopLoss()==0)
            {
               bool sellTsMod = OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(dnLinenow,digit),OrderTakeProfit(),0,Red);
               if (sellTsMod == false)
               {
                 ErrorCode = GetLastError();
	              ErrDesc   = ErrorDescription(ErrorCode);

	              ErrAlert  = StringConcatenate("Trailing Stop Modification ",ErrorCode,": ",ErrDesc);
	              if (ShowAlerts == true) Alert(ErrAlert);

	              ErrLog    = StringConcatenate("Ask: ",MarketInfo(s_symbol,MODE_ASK)," Ticket: ",OrderTicket()," Stop: ",OrderStopLoss());
	              Print(ErrLog);
               }
            }
         }
        break;
      }
   }
} 


//
//
//
//
//

void OpenBuy() 
{ 
    
   double lbStop = 0; if (lStopLoss>0)   lbStop = NormalizeDouble(Ask-lStopLoss  *Point*point,digit);
   double lbTake = 0; if (lTakeProfit>0) lbTake = NormalizeDouble(Ask+lTakeProfit*Point*point,digit);
   
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker) 
         OrderSend(s_symbol,OP_BUY,LotsOptimized(),Ask,Slippage*Point*point,lbStop,lbTake,Name_Expert,MAGIC,0,clOpenBuy); 
   else
   {
         int buyTicket    = OrderSend(s_symbol,OP_BUY,LotsOptimized(),Ask,Slippage*Point*point,0,0,Name_Expert,MAGIC,0,clOpenBuy);		    		    
         if (buyTicket   >= 0)
         bool buyOrderMod = OrderModify(buyTicket,OrderOpenPrice(),lbStop,lbTake,0,CLR_NONE);
         
         if (buyOrderMod  == false)
         {
         
           int    ErrorCode = GetLastError();
           string ErrDesc   = ErrorDescription(ErrorCode);

           string ErrAlert  = StringConcatenate("Modify Buy Order - Error ",ErrorCode,": ",ErrDesc);
           if (ShowAlerts   == true) Alert(ErrAlert);

           string ErrLog    = StringConcatenate("Ask: ",Ask," Bid: ",Bid," Ticket: ",buyTicket," Stop: ",lbStop," Profit: ",lbTake);
           Print(ErrLog);
         }
    }		       

}

//
//
//
//
//

void OpenSell() 
{ 
   double lsStop = 0; if (sStopLoss>0)   lsStop = NormalizeDouble(Bid+sStopLoss  *Point*point,digit);
   double lsTake = 0; if (sTakeProfit>0) lsTake = NormalizeDouble(Bid-sTakeProfit*Point*point,digit);
   
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker)
         OrderSend(s_symbol,OP_SELL,LotsOptimized(),Bid,Slippage*Point*point,lsStop,lsTake,Name_Expert,MAGIC,0,clOpenSell); 
   else
   {
         int sellTicket    = OrderSend(s_symbol,OP_SELL,LotsOptimized(),Bid,Slippage*Point*point,0,0,Name_Expert,MAGIC,0,clOpenSell);		    		    
         if (sellTicket    >= 0)
         bool sellOrderMod = OrderModify(sellTicket,OrderOpenPrice(),lsStop,lsTake,0,CLR_NONE);
         
         if (sellOrderMod  == false)
         {
           int    ErrorCode = GetLastError();
           string ErrDesc   = ErrorDescription(ErrorCode);

           string ErrAlert  = StringConcatenate("Modify Sell Order - Error ",ErrorCode,": ",ErrDesc);
           if (ShowAlerts   == true) Alert(ErrAlert);

           string ErrLog    = StringConcatenate("Ask: ",Ask," Bid: ",Bid," Ticket: ",sellTicket," Stop: ",lsStop," Profit: ",lsTake);
           Print(ErrLog);
         }
    }		       
} 

//
//
//
//
//

void CheckForClose()  
{
   RefreshRates();
   double xBuy   = iCustom(NULL,0,"PriceChannel_Stop_v1",cl.ChannelPeriod,cl.Risk,0,cl.entrybar);
   double xBuy1  = iCustom(NULL,0,"PriceChannel_Stop_v1",cl.ChannelPeriod,cl.Risk,0,cl.entrybar+1);
   double xSell  = iCustom(NULL,0,"PriceChannel_Stop_v1",cl.ChannelPeriod,cl.Risk,1,cl.entrybar);
   double xSell1 = iCustom(NULL,0,"PriceChannel_Stop_v1",cl.ChannelPeriod,cl.Risk,1,cl.entrybar+1);
   
   //
   //
   //
   //
   //
   
   for (int i = 0;i < OrdersTotal(); i++)
   {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false)  break;
      if (OrderMagicNumber()!= MAGIC)                         continue;
      if (OrderSymbol()     != s_symbol)                      continue;
      
      //
      //
      //
      //
      //
      
      if (OrderType() == OP_BUY)
      {
        if (xBuy==EMPTY_VALUE && xBuy1==EMPTY_VALUE && xSell!=EMPTY_VALUE && xSell1==EMPTY_VALUE && ((ItrendFilter && iTredn1 > iTredn3 && iTredn1 > iTredn2) ||!ItrendFilter)) 
        {
           bool buyClose = OrderClose(OrderTicket(),OrderLots(),Bid,Slippage*Point*point,clCloseBuy);
           if (buyClose == false)
           {
             int ErrorCode   = GetLastError();
             string ErrDesc  = ErrorDescription(ErrorCode);

             string ErrAlert = StringConcatenate("Close Buy Order - Error ",ErrorCode,": ",ErrDesc);
             if (ShowAlerts  == true) Alert(ErrAlert);

             string ErrLog   = StringConcatenate("Bid: ",Bid," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
             Print(ErrLog);
           }
        }
        break;
      }
      
      //
      //
      //
      //
      //
        
      if (OrderType() == OP_SELL)
      {
        if (xBuy!=EMPTY_VALUE && xBuy1==EMPTY_VALUE && xSell==EMPTY_VALUE && xSell1==EMPTY_VALUE && ((ItrendFilter && iTredn2 > iTredn3 && iTredn2 > iTredn1) ||!ItrendFilter)) 
        {
          bool sellClose = OrderClose(OrderTicket(),OrderLots(),Ask,Slippage*Point*point,clCloseSell); 
          if (sellClose  == false)
          {
             ErrorCode = GetLastError();
             ErrDesc   = ErrorDescription(ErrorCode);

             ErrAlert  = StringConcatenate("Close Sell Order - Error ",ErrorCode,": ",ErrDesc);
             if (ShowAlerts == true) Alert(ErrAlert);

             ErrLog   = StringConcatenate("Ask: ",Ask," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
             Print(ErrLog);
          }
        }
        break;
      }
   }
}

//
//
//
//
//

void CheckForClose2()  
{
   RefreshRates();
   double high = iCustom(NULL,0,"PriceChannel_Stop_v1",cl2.ChannelPeriod,cl2.Risk,0,cl2.entrybar);
   double low  = iCustom(NULL,0,"PriceChannel_Stop_v1",cl2.ChannelPeriod,cl2.Risk,1,cl2.entrybar);
   
   //
   //
   //
   //
   //
   
   for (int i = 0;i < OrdersTotal(); i++)
   {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false)  break;
      if (OrderMagicNumber()!= MAGIC)                         continue;
      if (OrderSymbol()     != s_symbol)                      continue;
      
      //
      //
      //
      //
      //
      
      if (OrderType() == OP_BUY)
      {
        if (Close[cl2.entrybar]==high) 
        {
           bool buyClose = OrderClose(OrderTicket(),OrderLots(),Bid,Slippage*Point*point,clCloseBuy);
           if (buyClose == false)
           {
             int ErrorCode   = GetLastError();
             string ErrDesc  = ErrorDescription(ErrorCode);

             string ErrAlert = StringConcatenate("Close Buy Order - Error ",ErrorCode,": ",ErrDesc);
             if (ShowAlerts  == true) Alert(ErrAlert);

             string ErrLog   = StringConcatenate("Bid: ",Bid," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
             Print(ErrLog);
           }
        }
        break;
      }
      
      //
      //
      //
      //
      //
        
      if (OrderType() == OP_SELL)
      {
        if (Close[cl2.entrybar]==low) 
        {
          bool sellClose = OrderClose(OrderTicket(),OrderLots(),Ask,Slippage*Point*point,clCloseSell); 
          if (sellClose  == false)
          {
             ErrorCode = GetLastError();
             ErrDesc   = ErrorDescription(ErrorCode);

             ErrAlert  = StringConcatenate("Close Sell Order - Error ",ErrorCode,": ",ErrDesc);
             if (ShowAlerts == true) Alert(ErrAlert);

             ErrLog   = StringConcatenate("Ask: ",Ask," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
             Print(ErrLog);
          }
        }
        break;
      }
   }
}


//
//
//
//
//

double LotsOptimized()
{
   double lot_min  = MarketInfo(s_symbol,MODE_MINLOT);
   double lot_max  = MarketInfo(s_symbol,MODE_MAXLOT);
   double lot_step = MarketInfo(s_symbol,MODE_LOTSTEP);
   double contract = MarketInfo(s_symbol,MODE_LOTSIZE);
   double lot      = Lots;
   int    orders   = HistoryTotal();     // history orders total
   int    losses   = 0;                  // number of losses orders without a break
   
   //
   //
   //
   //
   //
   
   if(lot_min < 0.0 || lot_max <= 0.0 || lot_step <= 0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage()<=0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   if (MaximumRisk > 0)
   {
   lot = NormalizeDouble(AccountFreeMargin() * MaximumRisk * AccountLeverage()/contract,2);
   }
   
   if(DecreaseFactor>0)
   {
      for(int i=orders-1;i>=0;i--)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
      if(OrderSymbol()!= s_symbol || OrderType() > OP_SELL) continue;
      
      //
      //
      //
      //
      //
      
      if(OrderProfit() > 0) break;
      if(OrderProfit() < 0) losses++;
      }
   if(losses>1) lot=NormalizeDouble(lot - lot * losses/DecreaseFactor,2);
   }
   
   //
   //
   //
   //
   //
   
   lot=NormalizeDouble(lot/lot_step,0)*lot_step;
   if(lot<lot_min) lot=lot_min;
   if(lot>lot_max) lot=lot_max;
   
return(lot);
} 

//
//
//
//
//

bool canOpen(int openWhat)
{
   if (!NoHedge) return(true);

   //
   //
   //
   //
   //
      
   for(int i=0; i < OrdersTotal(); i++)
   {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
      if (OrderSymbol() != s_symbol)                       continue;
      if (!StrictNoHedge && OrderMagicNumber() != MAGIC)   continue;
      
      if (OrderType() == OP_BUY  && openWhat == OP_SELL)   return(false); 
      if (OrderType() == OP_SELL && openWhat == OP_BUY)    return(false); 
   }      
   return(true);
}

//----------------------------------------------------------------------------------------
//           
//----------------------------------------------------------------------------------------
//
//
//
//
//

string normalizeTime(string time)
{
   int sepAt  = StringFind(time,":",0);
   int hour   = StrToInteger(StringSubstr(time,0,sepAt));
   int minute = StrToInteger(StringSubstr(time,sepAt+1,0));
   
   //
   //
   //
   //
   //
   
   hour   = MathMax(MathMin(hour  ,24),0);
   minute = MathMax(MathMin(minute,59),0);
   string answer="";
      while(true)
      {
         if (hour==0) { answer="00";     break; }
         if (hour<10) { answer="0"+hour; break; }
                        answer=    hour; break; 
      }                        
      while(true)
      {
         if (minute==0) { answer=answer+":00";       break; }
         if (minute<10) { answer=answer+":0"+minute; break; }
                          answer=answer+":" +minute; break; 
      }
   return(" "+answer); 
}

//
//
//
//
//

int GetMagic() 
{

   if (StringFind(s_symbol, "CADJPY") >= 0) return(1933921);
   if (StringFind(s_symbol, "CADCHF") >= 0) return(1933922);
   
   if (StringFind(s_symbol, "GOLD"  ) >= 0) return(1933931);
   if (StringFind(s_symbol, "SILVER") >= 0) return(1933932);
   
   if (StringFind(s_symbol, "NZDJPY") >= 0) return(1933941);
   if (StringFind(s_symbol, "NZDUSD") >= 0) return(1933942);
   
   if (StringFind(s_symbol, "CHFJPY") >= 0) return(1933951);
   
   if (StringFind(s_symbol, "EURAUD") >= 0) return(1933961);
   if (StringFind(s_symbol, "EURCAD") >= 0) return(1933962);
   if (StringFind(s_symbol, "EURUSD") >= 0) return(1933963);
   if (StringFind(s_symbol, "EURGBP") >= 0) return(1933964);
   if (StringFind(s_symbol, "EURCHF") >= 0) return(1933965);
   if (StringFind(s_symbol, "EURNZD") >= 0) return(1933966);
   if (StringFind(s_symbol, "EURJPY") >= 0) return(1933967);
   
   if (StringFind(s_symbol, "GBPUSD") >= 0) return(1933971);
   if (StringFind(s_symbol, "GBPCHF") >= 0) return(1933972);
   if (StringFind(s_symbol, "GBPJPY") >= 0) return(1933973);
   
   if (StringFind(s_symbol, "USDCHF") >= 0) return(1933981);
   if (StringFind(s_symbol, "USDJPY") >= 0) return(1933982);
   if (StringFind(s_symbol, "USDCAD") >= 0) return(1933983);

   if (StringFind(s_symbol, "AUDUSD") >= 0) return(1933991);
   if (StringFind(s_symbol, "AUDNZD") >= 0) return(1933992);
   if (StringFind(s_symbol, "AUDCAD") >= 0) return(1933993);
   if (StringFind(s_symbol, "AUDCHF") >= 0) return(1933994);
   if (StringFind(s_symbol, "AUDJPY") >= 0) return(1933995);
   
return(ManualMagic);
}



